<?php
// Author: Wesley Stessens
// License: MIT

$admin_email = "wesley@ubuntu.com";

$url_internat = "https://internat.khleuven.be/?q=rss.xml";
$url_projectwork = "https://projectwerk.khleuven.be/news.atom";

$prefix = "https://portaal.khleuven.be/";
$page_coursecal = "index.php?page=209";
$page_notices = "index.php?page=1";

$cookiejar = tempnam("cookies", "cookie-");

function getPage($url, $postData = false) {
  global $cookiejar;
  
  $ch = curl_init();
  
  curl_setopt($ch, CURLOPT_COOKIEJAR, $cookiejar);
  curl_setopt($ch, CURLOPT_COOKIEFILE, $cookiejar);
  curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_HEADER, true);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false); // If it works with verifypeer: enable it
  
  if ($postData) {
    curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);
  }
  
  curl_setopt($ch, CURLOPT_URL, $url);
  
  $page = curl_exec($ch);

  curl_close($ch);
  
  return $page;
}

getPage("https://portaal.khleuven.be/Shibboleth.sso/WAYF/khleuven?target=".urlencode($prefix.$page_coursecal));

// Cookies have been set, perform login through POST request now

$l = urlencode($_REQUEST['l']);
$p = urlencode($_REQUEST['p']);
$page = getPage("https://idp.khleuven.be:443/idp/view/login.htm", "username=$l&password=$p");

// Let's check if login succeeded by parsing the page

$loggedIn = false;
$notices = false;
$coursecal = false;

$pattern = '/id="username\.errors"/';
preg_match($pattern, $page, $matches);
$possiblyLoggedIn = count($matches) == 0;

if ($possiblyLoggedIn) {
  $pattern = '/href="\/Shibboleth\.sso\/Logout\?/';
  preg_match($pattern, $page, $matches);
  $loggedIn = count($matches) > 0;

  // We were auto-redirected to the personal course calendar page
  // So let's parse what we need from here

  $pattern = '/href="(export\.php\?what=uurrooster_studenten_persoonlijk[^"]*)"/';
  preg_match($pattern, $page, $matches);
  $coursecal = count($matches) > 1 ? $prefix.$matches[1] : false;

  // Now let's collect the notices feed for this user
  // And let's parse what we need from here

  $page = getPage($prefix.$page_notices);
  $pattern = '/href="(.*\/rss\.php\?[^"]*)"/';
  preg_match($pattern, $page, $matches);
  $notices = count($matches) > 1 ? $matches[1] : false;
  
  // Send e-mail if something is off
  if (!$loggedIn || !$coursecal || !$notices) {
    mail($admin_email, "UCLL Student App Back-end: Something might be wrong", "Please check the back-end shibproxy service.");
  }
}

// Clean up the cookiejar

unlink($cookiejar);

// echo date("H:i:s");

echo json_encode(array(
  'loggedIn' => $loggedIn,
  'feeds' => array(
    'notices' => $notices,
    'internat' => $url_internat,
    'projectwork' => $url_projectwork,
  ),
  'icals' => array(
    'coursecal' => $coursecal,
  ),
));
?>
